//
// Class CAbout for About Window 
// (show at the beginning of the execution)
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;

public class CAbout extends Window implements Runnable
{
  //Variables
  CGlobal g=null;
  int n_of_trigger;

  static Image img_about=null;
  Thread thrd=null;

  // *******************************************************************
  public CAbout(Frame dw, CGlobal glob, int xn_of_trigger)
  {
    super(dw);

    g=glob;
    n_of_trigger=xn_of_trigger;

    g.tg.trig[n_of_trigger]=false;

    String path="images"+g.cfg.GetParamStr(g.cfgSep)+"eos_c.gif";

    if (!CMisc.isFileExist(path))
    {
      System.out.println("Error: Can't find file /images/eos_c.gif!");
      System.exit(1);
    }

    long crc=CMisc.FileCRC(path);

    if (crc!=8763504)
    {
      System.out.println("File \"/images/eos_c.gif\" has been damaged!");
      System.exit(1);
    }

    img_about=Toolkit.getDefaultToolkit().getImage(path);

    if (img_about==null)
    {
      System.out.println("Error: Can't find file /images/eos_c.gif!");
      System.exit(1);
    }

    int wx=500;
    int wy=300;

    Dimension dim=Toolkit.getDefaultToolkit().getScreenSize();

    int mcx=dim.width;
    int mcy=dim.height;

    int cx=(mcx-wx)/2;
    int cy=(mcy-wy)/2;

    setBounds(cx, cy, wx, wy);

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    thrd=new Thread(this);
    thrd.start();		

    show();
  }

  // *******************************************************************
  public void run()
  {
    for (int i=0; i<4; i++)
    {
      try
      {
        thrd.sleep(500);
      }
      catch (InterruptedException e)
      {
        System.out.println("Error: Problems during work with thread in CAbout.class!");
        System.exit(1);
      }
    }

    g.tg.trig[n_of_trigger]=true;

    dispose();
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (e.getID() == Event.WINDOW_DESTROY)
    {
      g.tg.trig[n_of_trigger]=true;
      dispose();
    }
  }

  // *******************************************************************
  public void paint (Graphics g)
  {
    if (img_about != null) 
    {
      g.drawImage(img_about, 0, 0, this);
    }
  }			
}
