//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

import java.io.*;

public class CCopyAllFiles extends Dialog implements ActionListener, Runnable
{
  //Variables
  Dimension size;

  Label comp1;
  Button comp2;

  String str2="Cancel";
  
  Frame Parent=null;

  Thread thrd=null;

  int Status;

  CGlobal g=null;

  CFileManager fm=null;

  int index=0;

  // *******************************************************************
  public CCopyAllFiles(Frame dw, CGlobal glob, int index1)
  {
    super(dw, "Copying ...", true);

    Status=-1;
    index=index1;

    Parent=dw;

    int gap=10;

    g=glob;

    //First panel for border
    Panel p=new Panel();
    FlowLayout lt=new FlowLayout(FlowLayout.CENTER);
    lt.setHgap(gap);
    lt.setVgap(gap);

    setLayout(lt);
    add(p);

    BorderLayout lt0=new BorderLayout();
    lt0.setHgap(gap);
    lt0.setVgap(gap);

    FlowLayout lt1=new FlowLayout(FlowLayout.CENTER);

    FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

    Panel p0=new Panel();
    p0.setLayout(lt0);
  
    CFramedArea p1=new CFramedArea();
    p1.setLayout(lt1);

    Panel p2=new Panel();
    p2.setLayout(lt2);

    comp1=new Label("______________________________________________________________________________", Label.CENTER);

    comp2=new Button(str2);
    comp2.addActionListener(this);

    p.add(p0);
	
    p0.add("North", p1);
    p0.add("South", p2);

    p1.add(comp1);

    p2.add(comp2);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    setResizable(false);

    //File manager
    fm=new CFileManager();
    fm.Init(g.cfg.GetParamStr(g.cfgSep), 
            g.cfg.GetParamStr(g.cfgPath),
            g.plt.GetConfig(index).GetParamStr(g.pltPath),
            g.prj_path1);

    //Packing elements in window
    pack();

    size=getSize();
		
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
    AWTEvent.COMPONENT_EVENT_MASK);

    thrd=new Thread(this);
    thrd.start();		

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String command = e.getActionCommand();

    if (command.equals(str2))
    {	
      close_window();

      Status=-1;

      thrd.stop();

      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      close_window();

      Status=-1;

      thrd.stop();

      dispose();
    }
  }

  // *******************************************************************
  public void run()
  { 
    comp1.setText("______________________________________________________________________________");
    try
    {
      thrd.sleep(50);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    //
    try
    {
      thrd.sleep(500);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread!");
      System.exit(1);
    }

    comp1.setText("Copying original files to directory at EOS Server");

    //
    try
    {
      thrd.sleep(1000);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    String str1=g.cfg.GetParamStr(g.cfgPath);
    if (!str1.equals("")) str1=CMisc.ProcessDir(str1, 
                           g.cfg.GetParamStr(g.cfgSep));
    
    str1+=g.prj_path1;

    File fl=new File(str1);
    String[] fl_list=new String[16384];

    fl_list=fl.list();
    for (int qq=0; qq<fl_list.length; qq++)
    {
      comp1.setText("Copying "+fl_list[qq]+" ...");
      if (fm.sendFile(fl_list[qq])!=0)
      {
        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while coping files!");
        mb=null;

        System.gc();
        System.runFinalization();

        Status=-2;
        dispose();
        
        return;
      }

      try
      {
        thrd.sleep(50);
      }
      catch (InterruptedException e)
      {
        System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
        System.exit(1);
      }
    }

    try
    {
      thrd.sleep(1000);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    Status=0;
    dispose();
  }

  // *******************************************************************
  public int getStatus()
  {
    return Status;
  }

  // *******************************************************************
  public void close_window()
  {
  }
}
