//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class CEditPrjB_File extends Dialog implements ActionListener, ItemListener
{
  //Variables
  CGlobal g=null;

  Dimension size;

  List     lst=null;
  Label    lb=null;
  TextArea ta=null;
  Button   bt1=null;
  String   bs1="Ok";
  Button   bt2=null;
  String   bs2="Cancel";

  CProject cp=null;

  String prj_name="";

  Frame Parent=null;

  String file_name="";
  String file_ext="";

  int index=0;

  // *******************************************************************
  public CEditPrjB_File(Frame dw, CGlobal glob, 
                        int index1, CProject cp1, String prj_name1, int mode1)
  {
    super(dw, "Edit files", true);
 
    g=glob;

    Parent=dw;

    cp=cp1;

    int gap=3;

    index=index1;

    prj_name=prj_name1;

    file_name=cp.GetFileName(index);
    file_ext=cp.GetFileExt(index);

    Panel p1a1=new Panel();
    lst=new List(15);
    lst.addItemListener(this);
    lst.add("______________________________________________________________________________");

    p1a1.add(lst);

    Panel p1a2=new Panel();

    lb=new Label("0  ("+cp.GetFileName(index)+cp.GetFileExt(index)+")");
    p1a2.add(new Label("Line number: "));
    p1a2.add(lb);

    Panel p1a=new Panel();
    BorderLayout lt1a=new BorderLayout();
    lt1a.setHgap(gap);
    lt1a.setVgap(gap);
    p1a.setLayout(lt1a);

    p1a.add(p1a1, "North");
    p1a.add(p1a2, "South");

    Panel p1c1=new Panel();
    ta=new TextArea(10, 40);
    p1c1.add(ta);

    CFramedArea p1c2=new CFramedArea();
    BorderLayout lt1c2=new BorderLayout();
    lt1c2.setHgap(gap);
    lt1c2.setVgap(gap);
    p1c2.setLayout(lt1c2);
    p1c2.add(new Label("*file.f"), "North");
    if (mode1==2)
       p1c2.add(new Label("#001 258 266"), "South");
    else
       p1c2.add(new Label("#proc_mpc_1 258 266"), "South");

    Panel p1c3=new Panel();
    bt1=new Button(bs1);
    bt1.addActionListener(this);    
    bt2=new Button(bs2);
    bt2.addActionListener(this);    
    p1c3.add(bt1);
    p1c3.add(bt2);

    Panel p1c=new Panel();
    BorderLayout lt1c=new BorderLayout();
    lt1c.setHgap(gap);
    lt1c.setVgap(gap);
    p1c.setLayout(lt1c);

    p1c.add(p1c1, "North");
    p1c.add(p1c2, "Center");
    p1c.add(p1c3, "South");

    //First panel for border
    BorderLayout lt1=new BorderLayout();
    lt1.setHgap(gap);
    lt1.setVgap(gap);
    Panel p1=new Panel();
    p1.setLayout(lt1);

    p1.add(p1a, "North");
    p1.add(p1c, "South");

    add(p1);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    //Packing elements in window
    pack();

    lst.removeAll();

    //loading file
    BufferedReader fin=null;

    String str=g.cfg.GetParamStr(g.cfgPath);
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.prj_path1;
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=file_name+file_ext;

    try
    {
      fin=new BufferedReader(new FileReader(str));
    }
    catch (IOException e2)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    String str1="";
    try
    {
      while ((str1=fin.readLine())!=null)
      {
        lst.add(str1);
      }
    }
    catch (Exception e2)
    {
      try
      {
        fin.close();
      }
      catch (Exception e3)
      {}

      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while loading file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    try
    {
      fin.close();
    }
    catch (Exception e5)
    {
    }

    //check for info file
    if (CMisc.isFileExist(prj_name))
    {
      try
      {
        fin=new BufferedReader(new FileReader(prj_name));
      }
      catch (IOException e2)
      {
        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening file!");
        mb=null;

        System.gc();
        System.runFinalization();

        dispose();
        
        return;
      }

      try
      {
        while ((str1=fin.readLine())!=null)
        {
          ta.append(str1+"\n");
        }
      }
      catch (Exception e2)
      {
        try
        {
          fin.close();
        }
        catch (Exception e3)
        {}

        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while loading file!");
        mb=null;

        System.gc();
        System.runFinalization();

        dispose();
         
        return;
      }

      try
      {
        fin.close();
      }
      catch (Exception e5)
      {
      }
    }

    size=getSize();
		
    //Initializing parameters
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
                 AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String cm = e.getActionCommand();

    if (cm.equals(bs1)) 
    {	        
      String str1=ta.getText();

      BufferedWriter fout=null;

      try
      {
        fout=new BufferedWriter(new FileWriter(prj_name));
      }
      catch (IOException e2)
      {
        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening file!");
        mb=null;

        System.gc();
        System.runFinalization();

        dispose();
        
        return;
      }

      try
      {
        fout.write(str1);
      }
      catch (Exception e2)
      {
        try
        {
          fout.close();
        }
        catch (Exception e3)
        {}

        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while writing file!");
        mb=null;

        System.gc();
        System.runFinalization();

        dispose();
         
        return;
      }

      try
      {
        fout.close();
      }
      catch (Exception e5)
      {
      }

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }
    else if (cm.equals(bs2)) 
    {	        

      System.gc();
      System.runFinalization();

      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      dispose();
    }
  }

  // *******************************************************************
  public void itemStateChanged(ItemEvent e1)
  {
    int i=lst.getSelectedIndex()+1;

    lb.setText(String.valueOf(i)+"  ("+cp.GetFileName(index)+cp.GetFileExt(index)+")");
  }
}
