//
// Class CFrameMain
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class CFrameMain extends Frame implements ActionListener, ItemListener
{
  int xlm=500;
  int ylm=400;
  int menu_height=0;

  Dimension size;

  CGlobal g=null;

  String f_tmp = "_eos_client_tmp";

  //Menus
  String mFile="File";
  String mConf="Configuration";
  String mStep1="Prelim.Analysis";
  String mStep3="Iter.Compilation.";
  String mStep4="Perf.Prediction";
  String mStep5="Step_5";
  String mStep6="Mem.Profiling";

  String mHelp="Help";

  String mFile_NP= "New project";
  String mFile_OP= "Open project";
  String mFile_CP= "Close project";
  MenuItem miFile_CP;
  String mFile_SP= "Save project";
  MenuItem miFile_SP;
  String mFile_SPA="Save project as ...";
  MenuItem miFile_SPA;
  String mFile_E=  "Exit";

  String mConf_PO="Platform options";
  String mConf_GO="General options";

  String mStep1_AOL="All optimization levels";
  String mStep1_VR1="View results (1_1)";
  String mStep1_IF="Internal feedback";
  String mStep1_VR2="View results (1_2)";
  String mStep1_FIF="Fast internal feedback";
  String mStep1_VR3="View results (1_3)";
  String mStep1_RA="Run application";
  String mStep1_VR4="View results (1_4)";
  String mStep1_PA="Profile application";
  String mStep1_VR5="View results (1_5)";
  String mStep1_EPA="Separate subroutines (new_prj_ss)";

  String mStep3_CT="Create tree";
  String mStep3_VT="View tree 1";
  String mStep3_ET="Edit tree 2";
  String mStep3a_IN="Create prj & info files from the tree for loop profiling";
  String mStep3a_EI="Edit info file for loop profiling";
  String mStep3a_PR="Profile (loop or block level) application and create new prj (_llp)";
  String mStep3a_VR="View results (3a_1)";
  String mStep3_PR="Preliminary run";
  String mStep3_PRLLP="Preliminary run (LLP)";
  String mStep3_VR1="View results (3_1)";
  String mStep3_CNI="Calculate approximate number of iterations";
  String mStep3_VR2="View results (3_2)";
  String mStep3_RSS="Run search strategy";
  String mStep3_RSSLLP="Run search strategy (LLP)";
  String mStep3_RFT="Restore file with times";
  String mStep3_GR3="Get results (3_3)";
  String mStep3_VR3="View results (3_3)";

  String mStep4_CPP="Create prediction projects";
  String mStep4_CIF="Create prediction info file from tree file";
  String mStep4_EIF="Edit prediction info file";
  String mStep4_CA="Compile to asm";
  String mStep4_SS="Separate subroutines";
  String mStep4_PA="Profile application_b";
  String mStep4_VR1="View results (4_1)";

  String mStep5_RF1="Run feedback 1";
  String mStep5_VR1="View results (5_1)";
  String mStep5_MPC="Prediction transformation";
  String mStep5_VR2="View results (5_2)";
  String mStep5_PPC="Profile prediction code";
  String mStep5_VR3="View results (5_3)";

  String mStep6_RF2="Run feedback 2";
  String mStep6_VR1="View results (6_1)";
  String mStep6_CT="Calculate memory bandwidth time";
  String mStep6_VR2="View results (6_2)";

  String mHelp_A="About EOS Client";

  Menu mbStep1=null;
  Menu mbStep3=null;
  Menu mbStep4=null;
  Menu mbStep6=null;

  Button bLoad=null;
  String bsLoad="Load Project";

  Label lbProjectName1=null;
  Label lbRelPath=null;
  Label lbRelPath1=null;
  Label lbMainLang=null;
  Label lbMainLang1=null;
  Label lbNumFiles=null;
  Label lbNumFiles1=null;

  int cplt_cur=-1;

  Choice cplt=null;
  Button bEdit=null;
  String bsEdit="Edit";
  Label lbProcessor=null;
  Label lbProcessor1=null;
  Label lbOS=null;
  Label lbOS1=null;
  Label lbTimePr=null;
  Label lbTimePr1=null;
  Button bTP=null;
  String bsTP="Test";

  int ret=0;
  String str="";

  Label     lbOpt=null;
  TextField tf1=null;

  Label     lbOpt5=null;
  TextField tf5=null;

  Label     lbNOE=null;
  TextField tf_noe=null;

  Label     lbSSN=null;
  TextField tfSSN=null;

  Label     lbSFB=null;
  Checkbox  cbSFB=null;

  Label     lbAPO=null;
  Checkbox  cbAPO=null;

  Label     lbIO=null;
  Checkbox  cbIO=null;

  Label     lbRT=null;
  Checkbox  cbRT=null;

  Label     lbCD=null;
  Checkbox  cbCD=null;

  Label     lbRI=null;
  Checkbox  cbRI=null;

  Label     lbS=null;
  TextField tfS=null;

  Label     lbPP=null;
  TextField tfPP=null;

  Label     lbPT=null;
  TextField tfPT=null;

  Label     lbPU=null;
  TextField tfPU=null;

  Label     lbPG=null;
  TextField tfPG=null;

  Label     lbPR=null;
  TextField tfPR=null;

  Label     lbDep=null;
  TextField tf2=null;
  Label     lbCL=null;
  TextField tf3=null;

  Label     lbPass=null;
  TextField tf4=null;

  Button bSave=null;
  String bsSave="Save config";

  int upd_plt=0;

  // *******************************************************************
  public CFrameMain(CGlobal glob)
  {
    super("EOS Client 2.2");

    g=glob;
  }

  // *******************************************************************
  public void Init()
  {
    boolean check=false;

    int gap=2;

    int x=g.cfg.GetParamInt(g.cfgX);
    int y=g.cfg.GetParamInt(g.cfgY);
    int xl=g.cfg.GetParamInt(g.cfgXL);
    int yl=g.cfg.GetParamInt(g.cfgYL);

    if (xl<xlm) xl=xlm;
    if (yl<ylm) yl=ylm;

    if (g.cfg.GetParamInt(g.cfgSPS)==0)
    {
      x=10;
      y=10;
      xl=xlm;
      yl=ylm;
    }

    //Menu
    MenuBar mb=new MenuBar();

    Menu mbFile=new Menu(mFile);
    mbFile.add(new MenuItem(mFile_NP));
    mbFile.add(new MenuItem(mFile_OP));
    miFile_CP=new MenuItem(mFile_CP);
    mbFile.add(miFile_CP);
    mbFile.addSeparator();
    miFile_SP=new MenuItem(mFile_SP);
    mbFile.add(miFile_SP);
    miFile_SPA=new MenuItem(mFile_SPA);
    mbFile.add(miFile_SPA);
    mbFile.addSeparator();
    mbFile.add(new MenuItem(mFile_E));
    mbFile.addActionListener(this);

    Menu mbConf=new Menu(mConf);
    mbConf.add(new MenuItem(mConf_PO));
    mbConf.addSeparator();
    mbConf.add(new MenuItem(mConf_GO));
    mbConf.addActionListener(this);

    mbStep1=new Menu(mStep1);
    mbStep1.add(new MenuItem(mStep1_AOL));
    mbStep1.add(new MenuItem(mStep1_VR1));
    mbStep1.addSeparator();
    mbStep1.add(new MenuItem(mStep1_IF));
    mbStep1.add(new MenuItem(mStep1_VR2));
    mbStep1.addSeparator();
    mbStep1.add(new MenuItem(mStep1_FIF));
    mbStep1.add(new MenuItem(mStep1_VR3));
    mbStep1.addSeparator();
    mbStep1.add(new MenuItem(mStep1_RA));
    mbStep1.add(new MenuItem(mStep1_VR4));
    mbStep1.addSeparator();
    mbStep1.add(new MenuItem(mStep1_PA));
    mbStep1.add(new MenuItem(mStep1_VR5));
    mbStep1.addSeparator();
    mbStep1.add(new MenuItem(mStep1_EPA));
    mbStep1.addActionListener(this);

    mbStep3=new Menu(mStep3);
    mbStep3.add(new MenuItem(mStep3_CT));
    mbStep3.add(new MenuItem(mStep3_VT));
    mbStep3.add(new MenuItem(mStep3_ET));
    mbStep3.addSeparator();
    mbStep3.add(new MenuItem(mStep3a_IN));
    mbStep3.add(new MenuItem(mStep3a_EI));
    mbStep3.add(new MenuItem(mStep3a_PR));
    mbStep3.add(new MenuItem(mStep3a_VR));
    mbStep3.addSeparator();
    mbStep3.add(new MenuItem(mStep3_PR));
    mbStep3.add(new MenuItem(mStep3_PRLLP));
    mbStep3.add(new MenuItem(mStep3_VR1));
    mbStep3.addSeparator();
    mbStep3.add(new MenuItem(mStep3_CNI));
    mbStep3.add(new MenuItem(mStep3_VR2));
    mbStep3.addSeparator();
    mbStep3.add(new MenuItem(mStep3_RSS));
    mbStep3.add(new MenuItem(mStep3_RSSLLP));
    mbStep3.add(new MenuItem(mStep3_RFT));
    mbStep3.add(new MenuItem(mStep3_GR3));
    mbStep3.add(new MenuItem(mStep3_VR3));
    mbStep3.addActionListener(this);

    mbStep4=new Menu(mStep4);
    mbStep4.add(new MenuItem(mStep4_CPP));
    mbStep4.addSeparator();
    mbStep4.add(new MenuItem(mStep4_CIF));
    mbStep4.add(new MenuItem(mStep4_EIF));
    mbStep4.addSeparator();
    mbStep4.add(new MenuItem(mStep4_CA));
    mbStep4.add(new MenuItem(mStep4_SS));
    mbStep4.add(new MenuItem(mStep4_PA));
    mbStep4.add(new MenuItem(mStep4_VR1));
    mbStep4.addSeparator();
    mbStep4.add(new MenuItem(mStep5_RF1));
    mbStep4.add(new MenuItem(mStep5_VR1));
    mbStep4.addSeparator();
    mbStep4.add(new MenuItem(mStep5_MPC));
    mbStep4.add(new MenuItem(mStep5_VR2));
    mbStep4.addSeparator();
    mbStep4.add(new MenuItem(mStep5_PPC));
    mbStep4.add(new MenuItem(mStep5_VR3));
    mbStep4.addActionListener(this);

    mbStep6=new Menu(mStep6);
    mbStep6.add(new MenuItem(mStep6_RF2));
    mbStep6.add(new MenuItem(mStep6_VR1));
    mbStep6.addSeparator();
    mbStep6.add(new MenuItem(mStep6_CT));
    mbStep6.add(new MenuItem(mStep6_VR2));
    mbStep6.addActionListener(this);

    Menu mbHelp=new Menu(mHelp);
    mbHelp.add(new MenuItem(mHelp_A));
    mbHelp.addActionListener(this);

    mb.add(mbFile);
    mb.add(mbConf);
    mb.add(mbStep1);
    mb.add(mbStep3);
    mb.add(mbStep4);
    mb.add(mbStep6);
    mb.add(mbHelp);

    setMenuBar(mb);

    //
    setLocation(x,y);
    setBounds(x,y,xl,yl);
    setResizable(false);

    //Panel

    CFramedArea p1=new CFramedArea();
    BorderLayout gl1=new BorderLayout();
    gl1.setHgap(gap); gl1.setVgap(gap);
    p1.setLayout(gl1);

    Panel p1a=new Panel();
    GridLayout gl1a=new GridLayout(4,1);
    gl1a.setHgap(gap); gl1a.setVgap(gap);
    p1a.setLayout(gl1a);

    Panel p1b=new Panel();
    GridLayout gl1b=new GridLayout(4,1);
    gl1b.setHgap(gap); gl1b.setVgap(gap);
    p1b.setLayout(gl1b);

    Panel p1c=new Panel();
    GridLayout gl1c=new GridLayout(4,1);
    gl1c.setHgap(gap); gl1c.setVgap(gap);
    p1c.setLayout(gl1c);

    p1.add("West", p1a);
    p1.add("Center", p1b);
    p1.add("East", p1c);

    p1a.add(new Label("Project name:"));
    lbProjectName1=new Label("");
    p1b.add(lbProjectName1);
    bLoad=new Button(bsLoad);
    bLoad.addActionListener(this);
    p1c.add(bLoad);
    lbRelPath=new Label("Relative path:");
    p1a.add(lbRelPath);
    lbRelPath1=new Label("");
    p1b.add(lbRelPath1);
    p1c.add(new Label(""));
    lbMainLang=new Label("Main language:");
    p1a.add(lbMainLang);
    lbMainLang1=new Label("");
    p1b.add(lbMainLang1);
    p1c.add(new Label(""));
    lbNumFiles=new Label("Number of files:");
    p1a.add(lbNumFiles);
    lbNumFiles1=new Label("");
    p1b.add(lbNumFiles1);
    p1c.add(new Label(""));

    CFramedArea p2=new CFramedArea();
    BorderLayout gl2=new BorderLayout();
    gl2.setHgap(gap); gl2.setVgap(gap);
    p2.setLayout(gl2);

    Panel p2a=new Panel();
    GridLayout gl2a=new GridLayout(4,1);
    gl2a.setHgap(gap); gl2a.setVgap(gap);
    p2a.setLayout(gl2a);

    Panel p2b=new Panel();
    GridLayout gl2b=new GridLayout(4,1);
    gl2b.setHgap(gap); gl2b.setVgap(gap);
    p2b.setLayout(gl2b);

    Panel p2c=new Panel();
    GridLayout gl2c=new GridLayout(4,1);
    gl2c.setHgap(gap); gl2c.setVgap(gap);
    p2c.setLayout(gl2c);

    p2.add("West", p2a);
    p2.add("Center", p2b);
    p2.add("East", p2c);

    cplt = new Choice();
    cplt.add("____________________________________________________________________");

    cplt.addItemListener(this);

    p2a.add(new Label("Platform:"));
    p2b.add(cplt);
    bEdit=new Button(bsEdit);
    bEdit.addActionListener(this);
    p2c.add(bEdit);
    lbProcessor=new Label("Processor:");
    p2a.add(lbProcessor);
    lbProcessor1=new Label("");
    p2b.add(lbProcessor1);
    p2c.add(new Label(""));
    lbOS=new Label("OS:");
    p2a.add(lbOS);
    lbOS1=new Label("");
    p2b.add(lbOS1);
    p2c.add(new Label(""));
    lbTimePr=new Label("Time Precision:");
    p2a.add(lbTimePr);
    lbTimePr1=new Label("");
    p2b.add(lbTimePr1);
    bTP=new Button(bsTP);
    bTP.addActionListener(this);
    p2c.add(bTP);

    Panel p3a=new Panel();
    GridLayout gl3a=new GridLayout(9,6);
    gl3a.setHgap(gap); gl3a.setVgap(gap);
    p3a.setLayout(gl3a);

    lbOpt=new Label("Optimization:");
    tf1=new TextField("1", 1);
    str=g.cfg.GetParamStr(g.cfgOpt);
    if (!str.equals("")) tf1.setText(str);
    lbOpt5=new Label("Optimization1:");
    tf5=new TextField("2", 1);
    str=g.cfg.GetParamStr(g.cfgOpt1);
    if (!str.equals("")) tf5.setText(str);
    lbSSN=new Label("Search strategy:");
    tfSSN=new TextField("5c", 2);
    str=g.cfg.GetParamStr(g.cfgSSN);
    if (!str.equals("")) tfSSN.setText(str);
    lbSFB=new Label("Start from beg.:");
    cbSFB=new Checkbox("");
    check=true;
    str=g.cfg.GetParamStr(g.cfgSFB);
    if (!str.equals("1")) check=false;
    cbSFB.setState(check);
    lbAPO=new Label("Array Pad only:");
    cbAPO=new Checkbox("");
    check=true;
    str=g.cfg.GetParamStr(g.cfgAPO);
    if (!str.equals("1")) check=false;
    cbAPO.setState(check);
    lbIO=new Label("Ignore output:");
    cbIO=new Checkbox("");
    check=false;
    str=g.cfg.GetParamStr(g.cfgIO);
    if (str.equals("1")) check=true;
    cbIO.setState(check);
    lbRT=new Label("Record transf.:");
    cbRT=new Checkbox("");
    check=false;
    str=g.cfg.GetParamStr(g.cfgRT);
    if (str.equals("1")) check=true;
    cbRT.setState(check);
    lbCD=new Label("Create dirs:");
    cbCD=new Checkbox("");
    check=false;
    str=g.cfg.GetParamStr(g.cfgCD);
    if (str.equals("1")) check=true;
    cbCD.setState(check);
    lbRI=new Label("Record instr.:");
    cbRI=new Checkbox("");
    check=false;
    str=g.cfg.GetParamStr(g.cfgRI);
    if (str.equals("1")) check=true;
    cbRI.setState(check);
    lbS=new Label("Step:");
    tfS=new TextField("", 6);
    str=g.cfg.GetParamStr(g.cfgSTEP);
    if (!str.equals("")) tfS.setText(str);
    lbPP=new Label("Pad factors:");
    tfPP=new TextField("1,100,5", 10);
    str=g.cfg.GetParamStr(g.cfgPP);
    if (!str.equals("")) tfPP.setText(str);
    lbPT=new Label("Tile factors:");
    tfPT=new TextField("2,100,5", 10);
    str=g.cfg.GetParamStr(g.cfgPT);
    if (!str.equals("")) tfPT.setText(str);
    lbPU=new Label("Unroll factors:");
    tfPU=new TextField("1,100,5", 10);
    str=g.cfg.GetParamStr(g.cfgPU);
    if (!str.equals("")) tfPU.setText(str);
    lbPG=new Label("Grid factor:");
    tfPG=new TextField("2", 10);
    str=g.cfg.GetParamStr(g.cfgPG);
    if (!str.equals("")) tfPG.setText(str);
    lbPR=new Label("Random factor:");
    tfPR=new TextField("5", 10);
    str=g.cfg.GetParamStr(g.cfgPR);
    if (!str.equals("")) tfPR.setText(str);
    lbNOE=new Label("No. of executions:");
    tf_noe=new TextField("1", 1);
    str=g.cfg.GetParamStr(g.cfgNOE);
    if (!str.equals("")) tf_noe.setText(str);

    p3a.add(lbOpt);
    p3a.add(tf1);
    p3a.add(lbOpt5);
    p3a.add(tf5);
    p3a.add(new Label(""));
    p3a.add(new Label(""));

    p3a.add(lbSSN);
    p3a.add(tfSSN);
    p3a.add(new Label(""));
    p3a.add(new Label(""));
    p3a.add(new Label(""));
    p3a.add(new Label(""));

    p3a.add(lbPP);
    p3a.add(tfPP);
    p3a.add(lbPT);
    p3a.add(tfPT);
    p3a.add(lbPU);
    p3a.add(tfPU);

    p3a.add(lbPG);
    p3a.add(tfPG);
    p3a.add(lbPR);
    p3a.add(tfPR);
    p3a.add(new Label(""));
    p3a.add(new Label(""));

    p3a.add(lbSFB);
    p3a.add(cbSFB);
    p3a.add(lbAPO);
    p3a.add(cbAPO);
    p3a.add(lbS);
    p3a.add(tfS);

    p3a.add(lbIO);
    p3a.add(cbIO);
    p3a.add(lbRT);
    p3a.add(cbRT);
    p3a.add(lbCD);
    p3a.add(cbCD);

    lbDep=new Label("Dependency:");
    tf2=new TextField("1", 1);
    str=g.cfg.GetParamStr(g.cfgDep);
    if (!str.equals("")) tf2.setText(str);
    lbCL=new Label("Cache loop:");
    tf3=new TextField("5", 1);
    str=g.cfg.GetParamStr(g.cfgLoop);
    if (!str.equals("")) tf3.setText(str);

    p3a.add(lbDep);
    p3a.add(tf2);
    p3a.add(lbCL);
    p3a.add(tf3);
    p3a.add(new Label(""));
    p3a.add(new Label(""));

    lbPass=new Label("Pass:");
    tf4=new TextField("0", 1);
    str=g.cfg.GetParamStr(g.cfgPass);
    if (!str.equals("")) tf4.setText(str);

    p3a.add(lbPass);
    p3a.add(tf4);
    p3a.add(new Label(""));
    p3a.add(new Label(""));
    p3a.add(new Label(""));
    p3a.add(new Label(""));

//    bSave=new Button(bsSave);
//    bSave.addActionListener(this);

    p3a.add(lbRI);
    p3a.add(cbRI);
    p3a.add(new Label(""));
    p3a.add(new Label(""));
    p3a.add(lbNOE);
    p3a.add(tf_noe);

    CFramedArea p3=new CFramedArea();

    p3.add(p3a);

    Panel p=new Panel();
    BorderLayout gl=new BorderLayout ();
    gl.setHgap(gap); gl.setVgap(gap);
    p.setLayout(gl);

    p.add("North", p1);
    p.add("South", p2);
    p.add("Center", p3);

    add(p);

    pack();

    //
    project_enable(false);
    g.prj_loaded=false;
    g.prj_changed=true;

    if (upd_plt==0)
    {
      upd_plt=1;
      update_plt();
    }

    show();

    menu_height=getSize().height-yl;

    size=getSize();

    enableEvents(AWTEvent.WINDOW_EVENT_MASK|AWTEvent.COMPONENT_EVENT_MASK);
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String cm = e.getActionCommand();

    save_cfg();

    if (cm.equals(mFile_E))
    {	        
      close();
      System.exit(0);
    }
    else if (cm.equals(mHelp_A))
    {
      CAbout1 frame_about=new CAbout1(this, g);
      frame_about=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mConf_PO) || cm.equals(bsEdit))
    {
      CPlatOptWin pow=new CPlatOptWin(this, g);
      pow=null;

      g.cfg.SetParamStr(g.cfgPlat, String.valueOf(g.plt.GetPlatformsNum()));

      System.gc();
      System.runFinalization();

      update_plt();
    }
    else if (cm.equals(mConf_GO))
    {
      CGenOptWin gow=new CGenOptWin(this, g);
      gow=null;

      System.gc();
      System.runFinalization();

    }
    else if (cm.equals(mFile_NP))
    {
      FileDialog fd=new FileDialog(this, "New Project", FileDialog.LOAD);

      CPrjFilenameFilter cpff=new CPrjFilenameFilter();
      fd.setFilenameFilter(cpff);

      String path=g.cfg.GetParamStr(g.cfgPath);
      if (!path.equals(""))
      {
        path=CMisc.ProcessDir(path, g.cfg.GetParamStr(g.cfgSep));
        fd.setDirectory(path);
      }
      fd.show();

      String q1=fd.getFile();
      String q2=fd.getDirectory();

      if (q1==null) return;
                                                           
//      if (q1.length()>0) q1=q1.substring(0, q1.length()-1);

      String q3=q2+q1;

      CProject cp = new CProject();

      if (cp.Init(null, q3, g.prjMaxFiles)!=0)
      {
        CMsgBox mb=new CMsgBox(this, 1, "Error (internal): Can't initialize object CProject!");
        mb=null;

        System.gc();
        System.runFinalization();

        return;
      }

      if (g.prj_loaded)
      {
        prj_ask_to_save();

        g.prj=null;
        project_enable(false);

        g.prj_loaded=false;
        g.prj_changed=false;

        System.gc();
        System.runFinalization();
      }

      g.prj_name=q1;
      g.prj_path=CMisc.ProcessDir(q2, g.cfg.GetParamStr(g.cfgSep));

      if (g.prj_path.substring(0, path.length()).equalsIgnoreCase(path))
      {
        g.prj_path1=g.prj_path.substring(path.length(), g.prj_path.length());
      }
      else g.prj_path1=g.prj_path;

      g.prj=cp;
      cp=null;

      project_enable(true);

      g.prj_loaded=true;
      g.prj_changed=false;

      System.gc();
      System.runFinalization();

      project_enable(true);
    }
    else if (cm.equals(mFile_CP))
    {
      prj_ask_to_save();

      g.prj=null;
      project_enable(false);

      g.prj_loaded=false;
      g.prj_changed=false;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mFile_OP) || cm.equals(bsLoad))
    {
      FileDialog fd=new FileDialog(this, "Open Project", FileDialog.LOAD);

      CPrjFilenameFilter cpff=new CPrjFilenameFilter();
      fd.setFilenameFilter(cpff);

      String path=g.cfg.GetParamStr(g.cfgPath);
      if (!path.equals(""))
      {
        path=CMisc.ProcessDir(path, g.cfg.GetParamStr(g.cfgSep));
        fd.setDirectory(path);
      }
      fd.show();

      String q1=fd.getFile();
      String q2=fd.getDirectory();

      if (q1==null) return;

      String q3=q2+q1;

      CProject cp = new CProject();

      if (cp.Init(null, q3, g.prjMaxFiles)!=0)
      {
        CMsgBox mb=new CMsgBox(this, 1, "Error (internal): Can't initialize object CProject!");
        mb=null;

        System.gc();
        System.runFinalization();

        return;
      }

      if (cp.Parse()<0)
      {
        CMsgBox mb=new CMsgBox(this, 1, cp.GetLastError());
        mb=null;

        System.gc();
        System.runFinalization();

        return;
      }

      if (g.prj_loaded)
      {
        prj_ask_to_save();

        g.prj=null;
        project_enable(false);

        g.prj_loaded=false;
        g.prj_changed=false;

        System.gc();
        System.runFinalization();
      }

      g.prj_name=q1;
      g.prj_path=CMisc.ProcessDir(q2, g.cfg.GetParamStr(g.cfgSep));

      if (g.prj_path.substring(0, path.length()).equalsIgnoreCase(path))
      {
        g.prj_path1=g.prj_path.substring(path.length(), g.prj_path.length());
      }
      else g.prj_path1=g.prj_path;
      
      g.prj=cp;
      cp=null;

      project_enable(true);

      g.prj_loaded=true;
      g.prj_changed=false;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(bsSave))
    {
      save_cfg();
    }
    else if (cm.equals(mFile_SP))
    {
      if (g.prj_loaded) g.prj.Save();
      g.prj_changed=false;
    }
    else if (cm.equals(mFile_SPA))
    {
      FileDialog fd=new FileDialog(this, "Save Project As ...", FileDialog.LOAD);

      CPrjFilenameFilter cpff=new CPrjFilenameFilter();
      fd.setFilenameFilter(cpff);

      String path=g.cfg.GetParamStr(g.cfgPath);
      if (!path.equals(""))
      {
        path=CMisc.ProcessDir(path, g.cfg.GetParamStr(g.cfgSep));
        fd.setDirectory(path);
      }
      fd.show();

      String q1=fd.getFile();
      String q2=fd.getDirectory();

      if (q1==null) return;

//      if (q1.length()>0) q1=q1.substring(0, q1.length()-1);

      String q3=q2+q1;

      if (CMisc.isFileExist(q3+"1"))
      {
        CMsgBox mb=new CMsgBox(this, 0, "Overwrite Existing Project?");

        int ret=mb.getRet();

        mb=null;

        System.gc();
        System.runFinalization();

        if (ret!=1) return;
      }

      CProject cp = new CProject();

      if (cp.Init(g.prj, q3)!=0)
      {
        CMsgBox mb=new CMsgBox(this, 1, "Error (internal): Can't initialize object CProject!");
        mb=null;

        System.gc();
        System.runFinalization();

        return;
      }

      for (int i=1; i<g.prj.GetNumFiles(); i++)
      {
        cp.AddLine1(g.prj.GetLngNameOrig(i),
                    g.prj.GetFileName(i),
                    g.prj.GetFileExt(i),
                    g.prj.GetExtraOpt(i));
      }

      if (g.prj_loaded)
      {
        prj_ask_to_save();

        g.prj=null;
        project_enable(false);

        g.prj_loaded=false;
        g.prj_changed=false;

        System.gc();
        System.runFinalization();
      }

      g.prj=null;

      System.gc();
      System.runFinalization();

      g.prj_name=q1;
      g.prj_path=CMisc.ProcessDir(q2, g.cfg.GetParamStr(g.cfgSep));
      g.prj=cp;

      g.prj.Save();

      project_enable(true);

      g.prj_loaded=true;
      g.prj_changed=false;

      System.gc();
      System.runFinalization();

      project_enable(true);
    }
    else if (cm.equals(bsTP))
    {
      CTest ct=new CTest(this, g, cplt.getSelectedIndex());
      ct=null;

      update_plt();

      System.gc();
      System.runFinalization();
    }
//    else if (cm.equals(bsCD))
//    {
//      CCleanDir cd=new CCleanDir(this, g, cplt.getSelectedIndex());
//      cd=null;
//
//      System.gc();
//      System.runFinalization();
//    }
//    else if (cm.equals(bsCAF))
//    {
//      CCopyAllFiles caf=new CCopyAllFiles(this, g, cplt.getSelectedIndex());
//      caf=null;
//
//      System.gc();
//      System.runFinalization();
//    }
    else if (cm.equals(mStep1_AOL))
    {
      CRunAppAllOptLev craaol=new CRunAppAllOptLev(this, g, cplt.getSelectedIndex());
      craaol=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_VR1))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag1a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_IF))
    {
      CUseIntFeedback cuif=new CUseIntFeedback(this, g, cplt.getSelectedIndex());
      cuif=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_VR2))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag3a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_FIF))
    {
      FileDialog fd=new FileDialog(this, "Open Additional Project", FileDialog.LOAD);

      CPrjFilenameFilter cpff=new CPrjFilenameFilter();
      fd.setFilenameFilter(cpff);

      fd.setDirectory(g.prj_path1);
      fd.show();

      String q1=fd.getFile();
      if (q1==null) return;

      if (q1.length()>0) q1=q1.substring(0, q1.length()-1);

      g.prj_name_add=q1;

      CUseFastIntFeedback cufif=new CUseFastIntFeedback(this, g, cplt.getSelectedIndex(), tf1.getText());
      cufif=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_VR3))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag4a;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_RA))
    {
      CRunApp cra=new CRunApp(this, g, cplt.getSelectedIndex(), tf1.getText());
      cra=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_VR4))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag5a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_PA))
    {
      CProfApp cpa=new CProfApp(this, g, cplt.getSelectedIndex(), tf1.getText());
      cpa=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_VR5))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag6a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep1_EPA))
    {
      String q1=g.prj_name+g.prj_add_a1;
      String q2=g.prj_path;

      String q3=q2+q1;

      CProject cp = new CProject();

      if (CMisc.isFileExist(q3+"1"))
      {
        if (cp.Init(null, q3, g.prjMaxFiles)!=0)
        {
          CMsgBox mb=new CMsgBox(this, 1, "Error (internal): Can't initialize object CProject!");
          mb=null;
  
          System.gc();
          System.runFinalization();
  
          return;
        }

        if (cp.Parse()<0)
        {
          CMsgBox mb=new CMsgBox(this, 1, cp.GetLastError());
          mb=null;

          System.gc();
          System.runFinalization();

          return;
        }
      }
      else
      {
        if (cp.Init(g.prj, q3)!=0)
        {
          CMsgBox mb=new CMsgBox(this, 1, "Error (internal): Can't initialize object CProject!");
          mb=null;

          System.gc();
          System.runFinalization();

          return;
        }

        for (int i=1; i<g.prj.GetNumFiles(); i++)
        {
          cp.AddLine1(g.prj.GetLngNameOrig(i),
                      g.prj.GetFileName(i),
                      g.prj.GetFileExt(i),
                      g.prj.GetExtraOpt(i));
        }

        cp.Save();
      }

      CEditPrjA epa=new CEditPrjA(this, g, cp, q3);
      epa=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_CT))
    {
      CCreateTree1 cct=new CCreateTree1(this, g, cplt.getSelectedIndex());
      cct=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_VT))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag19a+"_1";

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_ET))
    {
      CEditTree cet=new CEditTree(this, g);
      cet=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_PR))
    {
      CPreRun cpr=new CPreRun(this, g, cplt.getSelectedIndex(), tf1.getText(), tf5.getText(), false);
      cpr=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_PRLLP))
    {
      CPreRun cpr=new CPreRun(this, g, cplt.getSelectedIndex(), tf1.getText(), tf5.getText(), true);
      cpr=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_VR1))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag20a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_CNI))
    {
      CCalcNumIter cpr=new CCalcNumIter(this, g, cplt.getSelectedIndex(),
                                                     tfSSN.getText(),
                                                     tfPP.getText(),
                                                     tfPT.getText(),
                                                     tfPU.getText(),
                                                     tfPG.getText(),
                                                     tfPR.getText(),
                                                     cbAPO.getState());

      cpr=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_VR2))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag22a+"."+tfSSN.getText();

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_RSS))
    {
      CRunSearchStrategy crss=new CRunSearchStrategy(this, g, cplt.getSelectedIndex(),
                                                     tf1.getText(), tf5.getText(),
                                                     tfSSN.getText(),
                                                     tfPP.getText(),
                                                     tfPT.getText(),
                                                     tfPU.getText(),
                                                     tfPG.getText(),
                                                     tfPR.getText(),
                                                     cbSFB.getState(),
                                                     tfS.getText(),
                                                     cbAPO.getState(),
                                                     cbIO.getState(),
                                                     cbRT.getState(),
                                                     cbCD.getState(),
                                                     false,
                                                     tf_noe.getText());
      crss=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_RSSLLP))
    {
      CRunSearchStrategy crss=new CRunSearchStrategy(this, g, cplt.getSelectedIndex(),
                                                     tf1.getText(), tf5.getText(),
                                                     tfSSN.getText(),
                                                     tfPP.getText(),
                                                     tfPT.getText(),
                                                     tfPU.getText(),
                                                     tfPG.getText(),
                                                     tfPR.getText(),
                                                     cbSFB.getState(),
                                                     tfS.getText(),
                                                     cbAPO.getState(),
                                                     cbIO.getState(),
                                                     cbRT.getState(),
                                                     cbCD.getState(),
                                                     true,
                                                     tf_noe.getText());
      crss=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_RFT))
    {
      CRestoreFileTime crft=new CRestoreFileTime(this, g, cplt.getSelectedIndex(),
                                                 tf1.getText(), tf5.getText(),
                                                 tfSSN.getText());
      crft=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_GR3))
    {
      CGetRes cvf=new CGetRes(this, g, cplt.getSelectedIndex(),
                              tf1.getText(), tf5.getText(), tfSSN.getText());
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3_VR3))
    {
      String x=g.f_diag23a+"."+tfSSN.getText()+"_"+tf1.getText()+"_"+tf5.getText();

      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=x;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3a_IN))
    {
      CInfoFile cif=new CInfoFile(this, g, cplt.getSelectedIndex(), g.f_diag27a, 2);
      cif=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3a_EI))
    {
      String q1=g.prj_name;
      String q2=g.prj_path;

      String q3=q2+q1;
      String q4=q2+g.f_diag27a;

      CProject cp = new CProject();

      if (cp.Init(null, q3, g.prjMaxFiles)!=0)
      {
        CMsgBox mb=new CMsgBox(this, 1, "Error (internal): Can't initialize object CProject!");
        mb=null;
  
        System.gc();
        System.runFinalization();
  
        return;
      }

      if (cp.Parse()<0)
      {
        CMsgBox mb=new CMsgBox(this, 1, cp.GetLastError());
        mb=null;

        System.gc();
        System.runFinalization();

        return;
      }

      CEditPrjB epb=new CEditPrjB(this, g, cp, q4, 2);
      epb=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3a_PR))
    {
      CRunApp3 cra2=new CRunApp3(this, g, cplt.getSelectedIndex(), tf5.getText());
      cra2=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep3a_VR))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag28a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep4_CPP))
    {
      CPredProj cpp=new CPredProj(this, g, cplt.getSelectedIndex());
      cpp=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep4_CIF))
    {
      CInfoFile cif=new CInfoFile(this, g, cplt.getSelectedIndex(), g.f_diag26a, 1);
      cif=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep4_EIF))
    {
      String q1=g.prj_name;
      String q2=g.prj_path;

      String q3=q2+q1;
      String q4=q2+g.f_diag26a;

      CProject cp = new CProject();

      if (cp.Init(null, q3, g.prjMaxFiles)!=0)
      {
        CMsgBox mb=new CMsgBox(this, 1, "Error (internal): Can't initialize object CProject!");
        mb=null;
  
        System.gc();
        System.runFinalization();
  
        return;
      }

      if (cp.Parse()<0)
      {
        CMsgBox mb=new CMsgBox(this, 1, cp.GetLastError());
        mb=null;

        System.gc();
        System.runFinalization();

        return;
      }

      CEditPrjB epb=new CEditPrjB(this, g, cp, q4, 1);
      epb=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep4_CA))
    {
      CCompileToAsm ccta=new CCompileToAsm(this, g, cplt.getSelectedIndex(), tf5.getText());
      ccta=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep4_SS))
    {
      CSepSub css=new CSepSub(this, g, cplt.getSelectedIndex(), tf5.getText());
      css=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep4_PA))
    {
      CRunApp2 cra2=new CRunApp2(this, g, cplt.getSelectedIndex(), tf5.getText());
      cra2=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep4_VR1))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag12a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep5_RF1))
    {
      CRunFB1 crfb1=new CRunFB1(this, g, cplt.getSelectedIndex(), tf5.getText());
      crfb1=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep5_VR1))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag13a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep6_RF2))
    {
      CRunFB2 crfb2=new CRunFB2(this, g, cplt.getSelectedIndex(), tf5.getText(), tf4.getText());
      crfb2=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep6_VR1))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag16a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep5_MPC))
    {
      CMPC cmpc=new CMPC(this, g, cplt.getSelectedIndex(), tf5.getText(), 
                         tf2.getText(), tf3.getText());
      cmpc=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep5_VR2))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag14a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep5_PPC))
    {
      CPMPC cpmpc=new CPMPC(this, g, cplt.getSelectedIndex(), tf5.getText());
      cpmpc=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep5_VR3))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag15a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep6_CT))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag16a;

      String strx=str;

      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag17a;

      String stry=str;

      CCalcTime cct=new CCalcTime(this, g, cplt.getSelectedIndex(), strx, stry);
      cct=null;

      System.gc();
      System.runFinalization();
    }
    else if (cm.equals(mStep6_VR2))
    {
      str=g.cfg.GetParamStr(g.cfgPath);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.prj_path1;
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.cfg.GetParamStr(g.cfgPath1);
      if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
      str+=g.f_diag17a;

      CViewFile cvf=new CViewFile(this, str);
      cvf=null;

      System.gc();
      System.runFinalization();
    }
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

/*
    Dimension size=getSize();

    int xl=size.width;
    int yl=size.height;

    if (xl<xlm || yl<ylm)
    {
      if (xl<xlm) xl=xlm;
      if (yl<ylm) yl=ylm;

      size.width=xl;
      size.height=yl;

      setSize(size);
    }
*/

    if (e.getID() == Event.WINDOW_DESTROY)
    {

      close();
      System.exit(0);
    }
  }

  // *******************************************************************
  private void close()
  {
    prj_ask_to_save();
    save_cfg();
  }

  // *******************************************************************
  private void save_cfg()
  {
    if (g.cfg.GetParamInt(g.cfgSPS)==1)
    {
      Point pt=getLocation();
      Dimension dm=getSize();

      String str="";

      str=String.valueOf(pt.x);
      g.cfg.SetParamStr(g.cfgX, str);

      str=String.valueOf(pt.y);
      g.cfg.SetParamStr(g.cfgY, str);

      str=String.valueOf(dm.width);
      g.cfg.SetParamStr(g.cfgXL, str);

      str=String.valueOf(dm.height-menu_height);
      g.cfg.SetParamStr(g.cfgYL, str);
    }

    String x="";
    g.cfg.SetParamStr(g.cfgOpt,  tf1.getText());
    g.cfg.SetParamStr(g.cfgDep,  tf2.getText());
    g.cfg.SetParamStr(g.cfgLoop, tf3.getText());
    g.cfg.SetParamStr(g.cfgPass, tf4.getText());
    g.cfg.SetParamStr(g.cfgOpt1, tf5.getText());
    g.cfg.SetParamStr(g.cfgSSN,  tfSSN.getText());
    g.cfg.SetParamStr(g.cfgPP,   tfPP.getText());
    g.cfg.SetParamStr(g.cfgPT,   tfPT.getText());
    g.cfg.SetParamStr(g.cfgPU,   tfPU.getText());
    g.cfg.SetParamStr(g.cfgPG,   tfPG.getText());
    g.cfg.SetParamStr(g.cfgPR,   tfPR.getText());
    g.cfg.SetParamStr(g.cfgSTEP, tfS.getText());
    x="0"; if (cbSFB.getState()) x="1";
    g.cfg.SetParamStr(g.cfgSFB,  x);
    x="0"; if (cbAPO.getState()) x="1";
    g.cfg.SetParamStr(g.cfgAPO,  x);
    x="0"; if (cbIO.getState())  x="1";
    g.cfg.SetParamStr(g.cfgIO,   x);
    x="0"; if (cbRT.getState())  x="1";
    g.cfg.SetParamStr(g.cfgRT,   x);
    x="0"; if (cbCD.getState())  x="1";
    g.cfg.SetParamStr(g.cfgCD,   x);
    x="0"; if (cbRI.getState())  x="1";
    g.cfg.SetParamStr(g.cfgRI,   x);
    g.cfg.SetParamStr(g.cfgNOE, tf_noe.getText());

    g.cfg.Save();
  }

  // *******************************************************************
  private void project_enable(boolean enable)
  {
    miFile_CP.setEnabled(enable);
    miFile_SP.setEnabled(enable);
    miFile_SPA.setEnabled(enable);

    mbStep1.setEnabled(enable);
    mbStep3.setEnabled(enable);
    mbStep4.setEnabled(enable);
    mbStep6.setEnabled(enable);

    lbRelPath.setEnabled(enable);
    lbMainLang.setEnabled(enable);
    lbNumFiles.setEnabled(enable);
    bTP.setEnabled(enable);
  
/*
    lbOpt.setEnabled(enable);
    tf1.setEnabled(enable);
    lbDep.setEnabled(enable);
    tf2.setEnabled(enable);
    lbCL.setEnabled(enable);
    tf3.setEnabled(enable);
    lbPass.setEnabled(enable);
    tf4.setEnabled(enable);
    lbOpt5.setEnabled(enable);
    tf5.setEnabled(enable);
    lbSSN.setEnabled(enable);
    tfSSN.setEnabled(enable);
    lbSFB.setEnabled(enable);
    cbSFB.setEnabled(enable);
    lbAPO.setEnabled(enable);
    cbAPO.setEnabled(enable);
    lbIO.setEnabled(enable);
    cbIO.setEnabled(enable);
    lbRT.setEnabled(enable);
    cbRT.setEnabled(enable);
    lbCD.setEnabled(enable);
    cbCD.setEnabled(enable);
    lbRI.setEnabled(enable);
    cbRI.setEnabled(enable);
    lbS.setEnabled(enable);
    tfS.setEnabled(enable);
    lbPP.setEnabled(enable);
    tfPP.setEnabled(enable);
    lbPT.setEnabled(enable);
    tfPT.setEnabled(enable);
    lbPU.setEnabled(enable);
    tfPU.setEnabled(enable);
    lbPG.setEnabled(enable);
    tfPG.setEnabled(enable);
    lbPR.setEnabled(enable);
    tfPR.setEnabled(enable);
    lbNOE.setEnabled(enable);
    tf_noe.setEnabled(enable);
*/
   
    if (enable)
    {
      lbProjectName1.setText(g.prj_name);
      lbRelPath1.setText(g.prj_path1);
      lbMainLang1.setText(g.prj.GetLngNameOrig(0));
      int nf=g.prj.GetNumFiles();
      if (nf>0) nf--;
      lbNumFiles1.setText(String.valueOf(nf));
    }
    else
    {
      lbProjectName1.setText("no project");
      lbRelPath1.setText("");
      lbMainLang1.setText("");
      lbNumFiles1.setText("");
    }

    create_all_filenames();
  }

  // *******************************************************************
  private void prj_ask_to_save()
  {
    if (g.prj_loaded)
    {
      if (g.prj_changed)
      {
        CMsgBox mb=new CMsgBox(this, 0, "Save Project?");

        int ret=mb.getRet();

        mb=null;

        System.gc();
        System.runFinalization();

        if (ret==1) g.prj.Save();

        g.prj_changed=false;
      }
    }
  }

  // *******************************************************************
  private void update_plt()
  {
    cplt.removeAll();

    int plt_num=g.plt.GetPlatformsNum();

    if (plt_num>0)
    {
      for (int i=0; i<plt_num; i++)
        cplt.add(g.plt.GetConfig(i).GetParamStr(g.pltName));
    }

    if (plt_num>0)
    {
      int j=g.cfg.GetParamInt(g.cfgPlt);
      if (j>=plt_num) j=0;

      choose_plt(j);
    }
    else
    {
      lbProcessor.setEnabled(false);
      lbProcessor1.setText("");
      lbOS.setEnabled(false);
      lbOS1.setText("");
      lbTimePr.setEnabled(false);
      lbTimePr1.setText("");
      bTP.setEnabled(false);
    }

    create_all_filenames();
  }

  // *******************************************************************
  private void choose_plt(int i)
  {
    cplt.select(i);
    cplt_cur=i;

    lbProcessor.setEnabled(true);
    lbProcessor1.setText(g.plt.GetConfig(i).GetParamStr(g.pltProc));
    lbOS.setEnabled(true);
    lbOS1.setText(g.plt.GetConfig(i).GetParamStr(g.pltOS));
    lbTimePr.setEnabled(true);
    lbTimePr1.setText(g.plt.GetConfig(i).GetParamStr(g.pltTimePrec));

    g.cfg.SetParamStr(g.cfgPlt, String.valueOf(i));

    create_all_filenames();
  }

  // *******************************************************************
  public void itemStateChanged(ItemEvent e1)
  {
    if (cplt_cur==-1) return;

    int i=cplt.getSelectedIndex();

    if (i!=-1 && i!=cplt_cur) choose_plt(i);
  }

  // *******************************************************************
  public void create_all_filenames()
  {
    int i=cplt.getSelectedIndex();

    if (i!=-1)
    {
      if (!g.prj_name.equals(""))
      {
        g.f_diag1a=g.f_diag1+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag2a=g.f_diag2+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag3a=g.f_diag3+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag4a=g.f_diag4+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag5a=g.f_diag5+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag6a=g.f_diag6+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag7a=g.f_diag7+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag8a=g.f_diag8+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag9a=g.f_diag9+"."+
                   g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                   g.prj_name;

        g.f_diag10a=g.f_diag10+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag11a=g.f_diag11+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag12a=g.f_diag12+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag12a2=g.f_diag12a1+"."+
                     g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                     g.prj_name;

        g.f_diag13a=g.f_diag13+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag14a=g.f_diag14+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag15a=g.f_diag15+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag15a2=g.f_diag15a1+"."+
                     g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                     g.prj_name;

        g.f_diag16a=g.f_diag16+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag17a=g.f_diag17+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag18a=g.f_diag18+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag19a=g.f_diag19+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag20a=g.f_diag20+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag21a=g.f_diag21+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag22a=g.f_diag22+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;


        g.f_diag23a=g.f_diag23+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag24a=g.f_diag24+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag25a=g.f_diag25+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag26a=g.f_diag26+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag27a=g.f_diag27+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag27a2=g.f_diag27a1+"."+
                     g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                     g.prj_name;

        g.f_diag28a=g.f_diag28+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;

        g.f_diag28a2=g.f_diag28a1+"."+
                     g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                     g.prj_name;

        g.f_diag29a=g.f_diag29+"."+
                    g.plt.GetConfig(cplt.getSelectedIndex()).GetParamStr(g.pltName)+"."+
                    g.prj_name;
      }
    }
  }
}
