//
// Class CGlobal for global variables and objects
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

public class CGlobal
{
  CConfig      cfg;
  CTrig        tg;
  CPlatforms   plt;
  CProject     prj;

  int platMax=128;

  int prjMaxFiles=4096;

  String prj_path="";
  String prj_path1="";
  String prj_name="";
  String prj_name_add="";
  String prj_add_a1="_ss";
  String prj_add_llp="_llp";
  String mpc_info="_eos_mpc_info";
  String s_tree="_eos_s_tree";

  boolean prj_loaded=false;
  boolean prj_changed=false;

  String f_diag1="eos_ao";            //All optimizations
  String f_diag1a="";
  String f_diag2="eos_tt";            //Time test
  String f_diag2a="";        
  String f_diag3="eos_if";            //Internal feedback
  String f_diag3a="";
  String f_diag4="eos_fif";           //Fast internal feedback
  String f_diag4a="";
  String f_diag5="eos_ra";            //Run application
  String f_diag5a="";
  String f_diag6="eos_pa";            //Profile application
  String f_diag6a="";
  String f_diag7="eos_ra_a";          //Run application_a
  String f_diag7a="";
  String f_diag8="eos_pa_a";          //Profile application_a
  String f_diag8a="";          
  String f_diag9="eos_am";            //Add mpcdummy
  String f_diag9a="";         
  String f_diag10="eos_ca";           //Compile to asm
  String f_diag10a="";
  String f_diag11="eos_ss";           //Separate subroutines
  String f_diag11a="";
  String f_diag12="eos_pa_b";         //Profile application_b
  String f_diag12a="";
  String f_diag12a1="eos_pa_b1";      //Profile application_b1
  String f_diag12a2="";
  String f_diag13="eos_fb1";          //Run feedback 1
  String f_diag13a="";
  String f_diag14="eos_mpc";          //MPC
  String f_diag14a="";
  String f_diag15="eos_p_mpc";        //Profile MPC
  String f_diag15a="";
  String f_diag15a1="eos_p_mpc1";     //Profile MPC1
  String f_diag15a2="";
  String f_diag16="eos_fb2";          //Run feedback 2
  String f_diag16a="";
  String f_diag17="eos_ct";           //Calculating time from feedback 2 and platform
  String f_diag17a="";
  String f_diag18="eos_ctr";          //Create tree
  String f_diag18a="";
  String f_diag19=s_tree;             //Tree file
  String f_diag19a="";
  String f_diag20="eos_s_pr";         //Preliminary run
  String f_diag20a="";
  String f_diag21="eos_s_pt";         //Preliminary time
  String f_diag21a="";
  String f_diag22="eos_s_cni";        //Calculate number of iterations
  String f_diag22a="";
  String f_diag23="eos_ss";           //Search Strategy
  String f_diag23a="";
  String f_diag24="eos_s_t";          //Search time
  String f_diag24a="";
  String f_diag25="eos_s_pp";         //Prediction projects
  String f_diag25a="";
  String f_diag26="_eos_mpc_info";    //Prediction info file
  String f_diag26a="";
  String f_diag27="_eos_llprof_info"; //Loop level profiling info file
  String f_diag27a="";
  String f_diag27a1="_eos_llprof_info1"; //Loop level profiling (creating prj & tree)
  String f_diag27a2="";
  String f_diag28="_eos_llprof";      //Loop level profiling EOS output
  String f_diag28a="";
  String f_diag28a1="_eos_llprof1";   //Loop level profiling Data
  String f_diag28a2="";
  String f_diag29="ic";               //Directory to keep iterative data
  String f_diag29a="";

  //Configuration
  int cfgSWA       =  0;  
  int cfgSPS       =  1;
  int cfgX         =  2;
  int cfgY         =  3;
  int cfgXL        =  4;
  int cfgYL        =  5;
  int cfgSep       =  6;
  int cfgPlat      =  7;
  int cfgPath      =  8;
  int cfgPlt       =  9;
  int cfgACPort    = 10;
  int cfgMPCPort   = 11;
  int cfgTPS       = 12;
  int cfgPath1     = 13;
  int cfgOpt       = 14;
  int cfgDep       = 15;
  int cfgLoop      = 16;
  int cfgPass      = 17;
  int cfgSPort     = 18;
  int cfgOpt1      = 19;
  int cfgSSN       = 20;
  int cfgPP        = 21;
  int cfgPT        = 22;
  int cfgPU        = 23;
  int cfgPG        = 24;
  int cfgPR        = 25;
  int cfgSFB       = 26;
  int cfgAPO       = 27;
  int cfgSTEP      = 28;
  int cfgIO        = 29;
  int cfgRT        = 30;
  int cfgCD        = 31;
  int cfgRI        = 32;
  int cfgNOE       = 33;

  //Platforms
  int pltName      =  0;
  int pltProc      =  1;
  int pltFreq      =  2;
  int pltMemory    =  3;
  int pltCacheL0   =  4;
  int pltCacheL1   =  5;
  int pltCacheL2   =  6;
  int pltOS        =  7;
  int pltOpt       =  8;
  int pltTimePrec  =  9;
  int pltHost      = 10;
  int pltPath      = 11;
}
