//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

import java.io.*;

public class CUseIntFeedback extends Dialog implements ActionListener, Runnable
{
  //Variables
  Dimension size;

  Label comp1;
  Button comp2;

  String str2="Cancel";
  
  Frame Parent=null;

  Thread thrd=null;

  int Status;

  CGlobal g=null;

  int index=0;

  int ret=0;

  String str="";

  // *******************************************************************
  public CUseIntFeedback(Frame dw, CGlobal glob, int index1)
  {
    super(dw, "Use internal feedback with all optimization levels ...", true);

    Status=-1;
    index=index1;

    Parent=dw;

    int gap=10;

    g=glob;

    //First panel for border
    Panel p=new Panel();
    FlowLayout lt=new FlowLayout(FlowLayout.CENTER);
    lt.setHgap(gap);
    lt.setVgap(gap);

    setLayout(lt);
    add(p);

    BorderLayout lt0=new BorderLayout();
    lt0.setHgap(gap);
    lt0.setVgap(gap);

    FlowLayout lt1=new FlowLayout(FlowLayout.CENTER);

    FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

    Panel p0=new Panel();
    p0.setLayout(lt0);
  
    CFramedArea p1=new CFramedArea();
    p1.setLayout(lt1);

    Panel p2=new Panel();
    p2.setLayout(lt2);

    comp1=new Label("______________________________________________________________________________", Label.CENTER);

    comp2=new Button(str2);
    comp2.addActionListener(this);

    p.add(p0);
	
    p0.add("North", p1);
    p0.add("South", p2);

    p1.add(comp1);

    p2.add(comp2);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    setResizable(false);

    //Packing elements in window
    pack();

//    comp1.setText("");

    size=getSize();
		
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
    AWTEvent.COMPONENT_EVENT_MASK);

    thrd=new Thread(this);
    thrd.start();		

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String command = e.getActionCommand();

    if (command.equals(str2))
    {	
      close_window();

      Status=-1;

      thrd.stop();

      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      close_window();

      Status=-1;

      thrd.stop();

      dispose();
    }
  }

  // *******************************************************************
  public void run()
  { 
    comp1.setText("______________________________________________________________________________");
    try
    {
      thrd.sleep(50);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    //
    try
    {
      thrd.sleep(500);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread!");
      System.exit(1);
    }

    comp1.setText("Initializing ...");

    //Create CClient for AC Server
    CClient cl=new CClient();
    cl.RecordInstructions(g.cfg.GetParamStr(g.cfgRI));
    if (cl.Init(g.plt.GetConfig(index).GetParamStr(g.pltHost),
                g.cfg.GetParamInt(g.cfgACPort),
                16)!=0)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error (internal): Can't initialize object CClient!");
      mb=null;

      System.gc();
      System.runFinalization();

      Status=-3;
      dispose();
        
      return;
    }

    //deleting diagnostic file
    str=g.cfg.GetParamStr(g.cfgPath);
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.prj_path1;
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.cfg.GetParamStr(g.cfgPath1);
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.f_diag3a;

    File fdel=null;
    try
    {
      fdel=new File(str);
      fdel.delete();
    }
    catch (NullPointerException e1)
    {}

    try
    {
      thrd.sleep(500);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    //
    comp1.setText("Sending commands to server to run application with main optimization levels ...");

    cl.Add("initiate ac",                                                 true, true);
    cl.Add("directory="+g.prj_path1,                                      true, true);
    cl.Add("file_project="+g.prj_name,                                    true, true);
    cl.Add("file_diag_out="+g.f_diag3a,                                   true, true);
    cl.Add("optimization="+g.plt.GetConfig(index).GetParamStr(g.pltOpt),  true, true);
    cl.Add("run_fdc" ,                                                    true, true);
    cl.Add("terminate",                                                  false, true);
    
    ret=cl.Send();

    if (ret<0)
    {
      if (ret==-1)
      {
        str="Error: Can't find host with AC Server!";
      }
      else if (ret==-2)
      {
        str="Error: Can't connect to AC Server!";
      }
      else if (ret==-4)
      {
        str="Error: Can't close connection with AC Server!";
      }
      else if (ret<0)
      {
        str=cl.GetLastError();
      }

      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, str);
      mb=null;

      System.gc();
      System.runFinalization();

      Status=-3;
      dispose();

      return;
    }

    //
    comp1.setText("Receiving diagnostic files from server ...");

    //it is important to have this delay here 
    //to allow server close dianostic file !!!
    try
    {
      thrd.sleep(1000);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    CFileManager fm=new CFileManager();
    fm.Init(g.cfg.GetParamStr(g.cfgSep), 
            g.cfg.GetParamStr(g.cfgPath),
            g.plt.GetConfig(index).GetParamStr(g.pltPath),
            g.prj_path1);

    if (fm.receiveFile(g.f_diag3a, g.cfg.GetParamStr(g.cfgPath1))!=0)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while receiving diag file!");
      mb=null;

      System.gc();
      System.runFinalization();

      Status=-2;
      dispose();
        
      return;
    }

    //
    try
    {
      thrd.sleep(500);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    Status=0;
    dispose();
  }

  // *******************************************************************
  public int getStatus()
  {
    return Status;
  }

  // *******************************************************************
  public void close_window()
  {
  }
}
