//
// Strategies
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;

public class Strategies_Search2a
{
  //**************************************************************************
  public static void Search2a(PrintWriter out,
                              CGlobal g,
                              BufferedWriter fout,
                              CProject cp,
                              CTree ctr,
                              CClient cl,
                              CTime ct1,
                              CTime ct9,
                              CTransformations1 ctrans,
                              int step1,
                              String str_prec,
                              String str_opt,
                              String str_fto1,
                              String str_fto2,
                              BufferedReader fin9,
                              boolean once,
                              int pt1, int pt2, int pt3,
                              int pu1, int pu2, int pu3,
                              int pp1, int pp2, int pp3,
                              boolean apo, boolean cdes,
                              String str_dir)
  {          
    int ret=0;

    int step=0;

    String str="";
   
    boolean transf=true;

    boolean x_tile=false;

    double tnew=0;

    if (pt1==0) pt1=2;
    if (pt2==0) pt2=20;
    if (pt3==0) pt3=1;
    if (pu1==0) pu1=2;
    if (pu2==0) pu2=20;
    if (pu3==0) pu3=1;
    if (pp1==0) pp1=1;
    if (pp2==0) pp2=20;
    if (pp3==0) pp3=1;

    double prec=0;
    try
    {
      prec=Double.valueOf(str_prec).doubleValue();
    }
    catch (NumberFormatException nfe1)
    {
      prec=0;
    }

    CTime ct;

    int i=0;
    int p=0;
    int j=0;

    double best_time=ct9.GetTime0();
    double best_time1=0;

    CTime bt=new CTime();
    CTime bt1=new CTime();

    bt.Copy(ct9);
    int s_best=-1;
    int s_best1=-1;
    int transf_pos=0;
    int transf_pos1=0;

    boolean compound=false;

    //Writing time
    BufferedWriter fout1=null;

    if (!once)
    {
      try
      {
        fout1=new BufferedWriter(new FileWriter(str_fto1));
      }
      catch (IOException e1)
      {
        out.println("Error: Can't open file for writing time!");
        out.flush();
        return;
      }
    }

    try
    {
      //Transformations
      boolean best_found=false;
      int     best_type=0;
      int     best_i=0;
      String  best_s="";

      int     best_type1=0;
      int     best_i1=0;
      String  best_s1="";

      int np=ctr.GetNumProcs();

      for (p=0; p<np; p++)
      {
        fout.write("*****************************************************************************");
        fout.newLine();

        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          String s_tile="";
          String s_unrl="";

          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=pt1; j<=pt2; j+=pt3)
              {
                if (step>step1 && once) return;

                step++;

                fout.write(CMisc.align_long(step, 5));
                fout.write(") Loop tiling");
                fout.newLine();
                fout.newLine();

                ctrans.RestoreQueuePosition(transf_pos);

                fout.write("         procedure: ");
                fout.write(ctr.GetProcL(p, i));
                fout.newLine();

                fout.write("     loop variable: ");
                fout.write(ctr.GetNameL(p, i));
                fout.newLine();

                fout.write("        loop index: ");
                fout.write(ctr.GetCountL(p, i));
                fout.newLine();

                s_tile=String.valueOf(j);
                fout.write("       tile factor: ");
                fout.write(s_tile);
                fout.newLine();

                ctrans.Add(2, 2, p, i, s_tile, "", true);

                fout.newLine();
                fout.flush();

                tnew=0;
                ret=0;

                if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
                else
                {
                  str=fin9.readLine();

                  int ind1=str.indexOf("'");
                  int ind2=str.indexOf("'", ind1+1);

                  if ((ind1!=-1) && (ind2!=-1))
                  {
                    ind1=str.indexOf("'", ind2+1);
                    ind2=str.indexOf("'", ind1+1);

                    String tmx=str.substring(ind1+1, ind2);

                    if ((ind1!=-1) && (ind2!=-1))
                    {
                      ind1=str.indexOf("'", ind2+1);
                      ind2=str.indexOf("'", ind1+1);

                      if ((ind1!=-1) && (ind2!=-1))
                      {
                        String retx=str.substring(ind1+1, ind2);

                        try
                        {
                          tnew=Double.valueOf(tmx).doubleValue();
                        }
                        catch (NumberFormatException nfe1)
                        {}

                        try
                        {
                          ret=Integer.valueOf(retx).intValue();
                        }
                        catch (NumberFormatException nfe2)
                        {}
                      }
                    }
                  }
                }

                if (ret<0)
                {
                  out.println(ctrans.GetLastError());
                  out.flush();
                  return;
                }
                else if (ret==1)
                {
                  fout.write("                                          [");
                  fout.write("exe was not created ...]");
                  fout.newLine();
                }
                else if (ret==2)
                {
                  fout.write("                                          [");
                  fout.write("output is incorrect ...]");
                  fout.newLine();
                }
                else if (ret==3)
                {
                  fout.write("                                          [");
                  fout.write("can't transform ...    ]");
                  fout.newLine();
                }
                else if (ret==0)
                {
                  if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

                  ct=ctrans.GetTime();
                  ct.Align(5,1);

                  tnew=ct.GetTime0();

                  if (!x_tile)
                  {
                    //if first iteration - make it best
                    best_time1=tnew+1;
                  }

                  fout.write("                            (transformed) [Time: ");
                  fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();
      
                  if (x_tile)
                  {
                    fout.write("                              (tile best) [Time: ");
                    fout.write(bt1.GetTimeStr1()+" + "+bt1.GetTimeStr2()+" = "+bt1.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
                  }

                  fout.write("                                   (best) [Time: ");
                  fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();

                  fout.write("                               (original) [Time: ");
                  fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();
   
                  double dt=best_time1-tnew;
                  if (dt>=prec)
                  {
                    if (x_tile)
                    {
                      fout.newLine();
                      fout.write("                      *** TILE BETTER *** [Time: ");
                      fout.write("                    ");
                      fout.write(CMisc.align_double(dt,5,1));
                      fout.write("]");
                      fout.newLine();
                    }

                    compound=true;

                    best_time1=tnew;
                    bt1.Copy(ct);
                    s_best1=step;
                    best_i1=i;
                    best_type1=2;
                    best_s1=s_tile;

                    x_tile=true;
                  }

                  fout.newLine();
                  fout.flush();
                }

                if (!once)
                {
                  fout1.write("'"+String.valueOf(step)+"', '"+
                                  String.valueOf(tnew)+"', '"+
                                  String.valueOf(ret)+"'");
                  fout1.newLine();
                  fout1.flush();
                }
              }
            }
            else
            {
              //loop unrolling
              if (x_tile)
              {
                //tiling + loop unrolling
                x_tile=false;

                ctrans.RestoreQueuePosition(transf_pos);
                ctrans.Add(2, best_type1, p, best_i1, best_s1, "", true);
                transf_pos1=ctrans.GetQueuePosition();

                fout.write("-----------------------------------------------------------------------------");
                fout.newLine();

                fout.write("Starting compound tile+unroll transformations...");
                fout.newLine();

                fout.write("-----------------------------------------------------------------------------");
                fout.newLine();

                for (j=pu1; j<=pu2; j+=pu3)
                {
                  if (step>step1 && once) return;

                  step++;

                  fout.write(CMisc.align_long(step, 5));
                  fout.write(") Loop unrolling");
                  fout.newLine();
                  fout.newLine();

                  ctrans.RestoreQueuePosition(transf_pos1);

                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  fout.write("       tile factor: ");
                  fout.write(best_s1);
                  fout.newLine();

                  s_unrl=String.valueOf(j);
                  fout.write("  unrolling factor: ");
                  fout.write(s_unrl);
                  fout.newLine();

                  ctrans.Add(2, 4, p, i, s_unrl, "", true);

                  fout.newLine();
                  fout.flush();

                  tnew=0;
                  ret=0;

                  if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
                  else
                  {
                    str=fin9.readLine();

                    int ind1=str.indexOf("'");
                    int ind2=str.indexOf("'", ind1+1);

                    if ((ind1!=-1) && (ind2!=-1))
                    {
                      ind1=str.indexOf("'", ind2+1);
                      ind2=str.indexOf("'", ind1+1);

                      String tmx=str.substring(ind1+1, ind2);
                
                      if ((ind1!=-1) && (ind2!=-1))
                      {
                        ind1=str.indexOf("'", ind2+1);
                        ind2=str.indexOf("'", ind1+1);

                        if ((ind1!=-1) && (ind2!=-1))
                        {
                          String retx=str.substring(ind1+1, ind2);

                          try
                          {
                            tnew=Double.valueOf(tmx).doubleValue();
                          }
                          catch (NumberFormatException nfe1)
                          {}

                          try
                          {
                            ret=Integer.valueOf(retx).intValue();
                          }
                          catch (NumberFormatException nfe2)
                          {}
                        }
                      }
                    }
                  }

                  if (ret<0)
                  {
                    out.println(ctrans.GetLastError());
                    out.flush();
                    return;
                  }
                  else if (ret==1)
                  {
                    fout.write("                                          [");
                    fout.write("exe was not created ...]");
                    fout.newLine();
                  }
                  else if (ret==2)
                  {
                    fout.write("                                          [");
                    fout.write("output is incorrect ...]");
                    fout.newLine();
                  }
                  else if (ret==3)
                  {
                    fout.write("                                          [");
                    fout.write("can't transform ...    ]");
                    fout.newLine();
                  }
                  else if (ret==0)
                  {
                    if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

                    ct=ctrans.GetTime();
                    ct.Align(5,1);

                    tnew=ct.GetTime0();
         
                    fout.write("                            (transformed) [Time: ");
                    fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
      
                    fout.write("                                   (best) [Time: ");
                    fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();

                    fout.write("                               (original) [Time: ");
                    fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
   
                    double dt=best_time-tnew;
                    if (dt>=prec)
                    {
                      fout.newLine();
                      fout.write("                           *** BETTER *** [Time: ");
                      fout.write("                    ");
                      fout.write(CMisc.align_double(dt,5,1));
                      fout.write("]");
                      fout.newLine();

                      if (best_time==-1)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=4;
                        best_s=s_unrl;
                        best_found=true;
                      }
                      else if (best_time>tnew)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=4;
                        best_s=s_unrl;
                        best_found=true;
                      }
                    }

                    fout.newLine();
                    fout.flush();
                  }

                  if (!once)
                  {
                    fout1.write("'"+String.valueOf(step)+"', '"+
                                    String.valueOf(tnew)+"', '"+
                                    String.valueOf(ret)+"'");
                    fout1.newLine();
                    fout1.flush();
                  }
                }
              }

              //just loop unrolling
              for (j=pu1; j<=pu2; j+=pu3)
              {
                if (step>step1 && once) return;

                step++;

                fout.write(CMisc.align_long(step, 5));
                fout.write(") Loop unrolling");
                fout.newLine();
                fout.newLine();

                ctrans.RestoreQueuePosition(transf_pos);

                fout.write("         procedure: ");
                fout.write(ctr.GetProcL(p, i));
                fout.newLine();

                fout.write("     loop variable: ");
                fout.write(ctr.GetNameL(p, i));
                fout.newLine();

                fout.write("        loop index: ");
                fout.write(ctr.GetCountL(p, i));
                fout.newLine();

                s_unrl=String.valueOf(j);
                fout.write("  unrolling factor: ");
                fout.write(s_unrl);
                fout.newLine();

                ctrans.Add(2, 4, p, i, s_unrl, "", true);

                fout.newLine();
                fout.flush();

                tnew=0;
                ret=0;

                if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
                else
                {
                  str=fin9.readLine();

                  int ind1=str.indexOf("'");
                  int ind2=str.indexOf("'", ind1+1);

                  if ((ind1!=-1) && (ind2!=-1))
                  {
                    ind1=str.indexOf("'", ind2+1);
                    ind2=str.indexOf("'", ind1+1);

                    String tmx=str.substring(ind1+1, ind2);

                    if ((ind1!=-1) && (ind2!=-1))
                    {
                      ind1=str.indexOf("'", ind2+1);
                      ind2=str.indexOf("'", ind1+1);

                      if ((ind1!=-1) && (ind2!=-1))
                      {
                        String retx=str.substring(ind1+1, ind2);

                        try
                        {
                          tnew=Double.valueOf(tmx).doubleValue();
                        }
                        catch (NumberFormatException nfe1)
                        {}

                        try
                        {
                          ret=Integer.valueOf(retx).intValue();
                        }
                        catch (NumberFormatException nfe2)
                        {}
                      }
                    }
                  }
                }

                if (ret<0)
                {
                  out.println(ctrans.GetLastError());
                  out.flush();
                  return;
                }
                else if (ret==1)
                {
                  fout.write("                                          [");
                  fout.write("exe was not created ...]");
                  fout.newLine();
                }
                else if (ret==2)
                {
                  fout.write("                                          [");
                  fout.write("output is incorrect ...]");
                  fout.newLine();
                }
                else if (ret==3)
                {
                  fout.write("                                          [");
                  fout.write("can't transform ...    ]");
                  fout.newLine();
                }
                else if (ret==0)
                {
                  if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

                  ct=ctrans.GetTime();
                  ct.Align(5,1);

                  tnew=ct.GetTime0();

                  fout.write("                            (transformed) [Time: ");
                  fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();
      
                  fout.write("                                   (best) [Time: ");
                  fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();

                  fout.write("                               (original) [Time: ");
                  fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();
   
                  double dt=best_time-tnew;
                  if (dt>=prec)
                  {
                    compound=false;

                    fout.newLine();
                    fout.write("                           *** BETTER *** [Time: ");
                    fout.write("                    ");
                    fout.write(CMisc.align_double(dt,5,1));
                    fout.write("]");
                    fout.newLine();

                    if (best_time==-1)
                    {
                      best_time=tnew;
                      bt.Copy(ct);
                      s_best=step;
                      best_i=i;
                      best_type=4;
                      best_s=s_unrl;
                      best_found=true;
                    }
                    else if (best_time>tnew)
                    {
                      best_time=tnew;
                      bt.Copy(ct);
                      s_best=step;
                      best_i=i;
                      best_type=4;
                      best_s=s_unrl;
                      best_found=true;
                    }
                  }

                  fout.newLine();
                  fout.flush();
                }

                if (!once)
                {
                  fout1.write("'"+String.valueOf(step)+"', '"+
                                  String.valueOf(tnew)+"', '"+
                                  String.valueOf(ret)+"'");
                  fout1.newLine();
                  fout1.flush();
                }
              }

              //Choosing best transformation
              if (best_found)
              {
                best_found=false;

                //Choosing best transformation
                fout.write("-----------------------------------------------------------------------------");
                fout.newLine();
 
                fout.write("Best transformation found for:");
                fout.newLine();
                fout.write(" loop ");

                if (compound)
                {
                  fout.write(ctr.GetCountL(p, best_i1));
                  fout.write(" (step=");
                  fout.write(String.valueOf(s_best1));
                  fout.write(")!");
                  fout.newLine();

                  ctrans.RestoreQueuePosition(transf_pos);
                  ctrans.Add(2, best_type1, p, best_i1, best_s1, "", true);
                  transf_pos=ctrans.GetQueuePosition();
                }

                fout.write(" loop ");
                fout.write(ctr.GetCountL(p, best_i));
                fout.write(" (step=");
                fout.write(String.valueOf(s_best));
                fout.write(")!");
                fout.newLine();

                ctrans.RestoreQueuePosition(transf_pos);
                ctrans.Add(2, best_type, p, best_i, best_s, "", true);
                transf_pos=ctrans.GetQueuePosition();

                fout.newLine();
                fout.write("Next transformations will include the above transformation!");
                fout.newLine();

                fout.write("-----------------------------------------------------------------------------");
                fout.newLine();

                fout.flush();
              }
            }
          }
        }
      }

      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
        fout.write("*****************************************************************************");
        fout.newLine();

        for (i=0; i<nac; i++)
        {
          //common array padding
          for (j=pp1; j<=pp2; j+=pp3)
          {
            if (step>step1 && once) return;

            step++;

            fout.write(CMisc.align_long(step, 5));
            fout.write(") Common array padding");
            fout.newLine();
            fout.newLine();

            ctrans.RestoreQueuePosition(transf_pos);

            fout.write("    array variable: ");
            fout.write(ctr.GetNameAC(i));
            fout.newLine();

            String s_pad=String.valueOf(j);
            fout.write("    padding factor: ");
            fout.write(s_pad);
            fout.newLine();

            ctrans.Add(0, 0, 0, i, s_pad, "", false);

            fout.newLine();
            fout.flush();

            tnew=0;
            ret=0;

            if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
            else
            {
              str=fin9.readLine();

              int ind1=str.indexOf("'");
              int ind2=str.indexOf("'", ind1+1);

              if ((ind1!=-1) && (ind2!=-1))
              {
                ind1=str.indexOf("'", ind2+1);
                ind2=str.indexOf("'", ind1+1);

                String tmx=str.substring(ind1+1, ind2);

                if ((ind1!=-1) && (ind2!=-1))
                {
                  ind1=str.indexOf("'", ind2+1);
                  ind2=str.indexOf("'", ind1+1);

                  if ((ind1!=-1) && (ind2!=-1))
                  {
                    String retx=str.substring(ind1+1, ind2);

                    try
                    {
                      tnew=Double.valueOf(tmx).doubleValue();
                    }
                    catch (NumberFormatException nfe1)
                    {}

                    try
                    {
                      ret=Integer.valueOf(retx).intValue();
                    }
                    catch (NumberFormatException nfe2)
                    {}
                  }
                }
              }
            }

            if (ret<0)
            {
              out.println(ctrans.GetLastError());
              out.flush();
              return;
            }
            else if (ret==1)
            {
              fout.write("                                          [");
              fout.write("exe was not created ...]");
              fout.newLine();
            }
            else if (ret==2)
            {
              fout.write("                                          [");
              fout.write("output is incorrect ...]");
              fout.newLine();
            }
            else if (ret==3)
            {
              fout.write("                                          [");
              fout.write("can't transform ...    ]");
              fout.newLine();
            }
            else if (ret==0)
            {
              if (step<=step1) ctrans.SetTime(String.valueOf(tnew));

              ct=ctrans.GetTime();
              ct.Align(5,1);

              tnew=ct.GetTime0();

              fout.write("                            (transformed) [Time: ");
              fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
              fout.write("]");
              fout.newLine();
     
              fout.write("                                   (best) [Time: ");
              fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              fout.write("                               (original) [Time: ");
              fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
              fout.write("]");
              fout.newLine();
   
              double dt=best_time-tnew;
              if (dt>=prec)
              {
                fout.newLine();
                fout.write("                           *** BETTER *** [Time: ");
                fout.write("                    ");
                fout.write(CMisc.align_double(dt,5,1));
                fout.write("]");
                fout.newLine();

                if (best_time==-1)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  best_i=i;
                  best_type=0;
                  best_s=s_pad;
                  best_found=true;
                }
                else if (best_time>tnew)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  best_i=i;
                  best_type=0;
                  best_s=s_pad;
                  best_found=true;
                }
              }

              fout.newLine();
              fout.flush();
            }

            if (!once)
            {
              fout1.write("'"+String.valueOf(step)+"', '"+
                              String.valueOf(tnew)+"', '"+
                              String.valueOf(ret)+"'");
              fout1.newLine();
              fout1.flush();
            }
          }

          //Choosing best transformation
          if (best_found)
          {
            best_found=false;

            //Choosing best transformation
            fout.write("-----------------------------------------------------------------------------");
            fout.newLine();

            fout.write("Best transformation found for:");
            fout.newLine();

            fout.write(" array ");
            fout.write(ctr.GetNameAC(best_i));
            fout.write(" (step=");
            fout.write(String.valueOf(s_best));
            fout.write(")!");
            fout.newLine();

            ctrans.RestoreQueuePosition(transf_pos);
            ctrans.Add(0, best_type, 0, best_i, best_s, "", false);
            transf_pos=ctrans.GetQueuePosition();

            fout.newLine();
            fout.write("Next transformations will include the above transformation!");
            fout.newLine();

            fout.write("-----------------------------------------------------------------------------");
            fout.newLine();

            fout.flush();
          }
        }
      }

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        fout.write("*****************************************************************************");
        fout.newLine();

        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
          fout.write("No non-common arrays to transform!");
          fout.newLine();
        }
        else 
        {
          for (i=0; i<na; i++)
          {
            for (j=pp1; j<=pp2; j+=pp3)
            {
              if (step>step1 && once) return;

              step++;
          
              fout.write(CMisc.align_long(step, 5));
              fout.write(") Non-common array padding");
              fout.newLine();
              fout.newLine();

              ctrans.RestoreQueuePosition(transf_pos);

              fout.write("         procedure: ");
              fout.write(ctr.GetProc(p));
              fout.newLine();

              fout.write("    array variable: ");
              fout.write(ctr.GetNameA(p,i));
              fout.newLine();

              String s_pad=String.valueOf(j);
              fout.write("    padding factor: ");
              fout.write(s_pad);
              fout.newLine();
    
              ctrans.Add(1, 0, p, i, s_pad, "", false);

              fout.newLine();
              fout.flush();

              tnew=0;
              ret=0;

              if (step>step1) ret=ctrans.Transform(transf, step, once, cdes);
              else
              {
                str=fin9.readLine();

                int ind1=str.indexOf("'");
                int ind2=str.indexOf("'", ind1+1);

                if ((ind1!=-1) && (ind2!=-1))
                {
                  ind1=str.indexOf("'", ind2+1);
                  ind2=str.indexOf("'", ind1+1);

                  String tmx=str.substring(ind1+1, ind2);

                  if ((ind1!=-1) && (ind2!=-1))
                  {
                    ind1=str.indexOf("'", ind2+1);
                    ind2=str.indexOf("'", ind1+1);

                    if ((ind1!=-1) && (ind2!=-1))
                    {
                      String retx=str.substring(ind1+1, ind2);

                      try
                      {
                        tnew=Double.valueOf(tmx).doubleValue();
                      }
                      catch (NumberFormatException nfe1)
                      {}

                      try
                      {
                        ret=Integer.valueOf(retx).intValue();
                      }
                      catch (NumberFormatException nfe2)
                      {}
                    }
                  }
                }
              }

              if (ret<0)
              {
                out.println(ctrans.GetLastError());
                out.flush();
                return;
              }
              else if (ret==1)
              {
                fout.write("                                          [");
                fout.write("exe was not created ...]");
                fout.newLine();
              }
              else if (ret==2)
              {
                fout.write("                                          [");
                fout.write("output is incorrect ...]");
                fout.newLine();
              }
              else if (ret==3)
              {
                fout.write("                                          [");
                fout.write("can't transform ...    ]");
                fout.newLine();
              }  
              else if (ret==0)
              {
                if (step<=step1) ctrans.SetTime(String.valueOf(tnew));
          
                ct=ctrans.GetTime();
                ct.Align(5,1);

                tnew=ct.GetTime0();

                fout.write("                            (transformed) [Time: ");
                fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                fout.write("]");
                fout.newLine();
     
                fout.write("                                   (best) [Time: ");
                fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                fout.write("]");
                fout.newLine();

                fout.write("                               (original) [Time: ");
                fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
                fout.write("]");
                fout.newLine();
   
                double dt=best_time-tnew;
                if (dt>=prec)
                {
                  fout.newLine();
                  fout.write("                           *** BETTER *** [Time: ");
                  fout.write("                    ");
                  fout.write(CMisc.align_double(dt,5,1));
                  fout.write("]");
                  fout.newLine();

                  if (best_time==-1)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    best_i=i;
                    best_s=s_pad;
                    best_found=true;
                  }
                  else if (best_time>tnew)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    best_i=i;
                    best_s=s_pad;
                    best_found=true;
                  }
                }

                fout.newLine();
                fout.flush();
              }

              if (!once)
              {
                fout1.write("'"+String.valueOf(step)+"', '"+
                                String.valueOf(tnew)+"', '"+
                                String.valueOf(ret)+"'");
                fout1.newLine();
                fout1.flush();
              }
            }

            //Choosing best transformation
            if (best_found)
            {
              best_found=false;

              //Choosing best transformation
              fout.write("-----------------------------------------------------------------------------");
              fout.newLine();

              fout.write("Best transformation found for:");
              fout.newLine();

              fout.write(" array ");
              fout.write(ctr.GetNameA(p,best_i));
              fout.write(" (step=");
              fout.write(String.valueOf(s_best));
              fout.write(")!");
              fout.newLine();

              ctrans.RestoreQueuePosition(transf_pos);
              ctrans.Add(1, 0, p, best_i, best_s, "", false);
              transf_pos=ctrans.GetQueuePosition();

              fout.newLine();
              fout.write("Next transformations will include the above transformation!");
              fout.newLine();

              fout.write("-----------------------------------------------------------------------------");
              fout.newLine();

              fout.flush();
            }
          }
        }
      }

      fout.flush();

      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Result: ");
      fout.newLine();
      fout.newLine();

      if (s_best!=-1)
      {
        fout.write("                                   (best) [Time: ");
        fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
        fout.write("]");
        fout.newLine();

        fout.write("                              (original) [TimeA: ");
        fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
        fout.write("]");
        fout.newLine();

        fout.write("                              (original) [TimeB: ");
        fout.write(ct9.GetTimeStr1()+" + "+ct9.GetTimeStr2()+" = "+ct9.GetTimeStr0());
        fout.write("]");
        fout.newLine();
   
        double dt=ct1.GetTime0()-best_time;
        double dp=0;

        if (dt>0)
        {
          fout.newLine();
          fout.write("                          *** BETTER *** [TimeA: ");
          fout.write("                    ");
          fout.write(CMisc.align_double(dt,5,1));
          fout.write("]");
          fout.newLine();
          fout.newLine();
        
          fout.write("                                          [      ");
          fout.write("                     ");
          dp=dt*100/ct1.GetTime0();  
          fout.write(CMisc.align_double(dp,3,1)+"%");
          fout.write("]");
          fout.newLine();
        }

        dt=ct9.GetTime0()-best_time;
        fout.newLine();
        fout.write("                          *** BETTER *** [TimeB: ");
        fout.write("                    ");
        fout.write(CMisc.align_double(dt,5,1));
        fout.write("]");
        fout.newLine();
        fout.newLine();
        
        fout.write("                                          [      ");
        fout.write("                     ");
        dp=dt*100/ct9.GetTime0();  
        fout.write(CMisc.align_double(dp,3,1)+"%");
        fout.write("]");
        fout.newLine();

        fout.newLine();
        fout.write("Last step with improvement: "+String.valueOf(s_best));
        fout.newLine();
      }
      else
      {
        fout.write("Best combined transformation was not found!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    if (!once)
    {
      try
      {
        fout1.close();
      }
      catch (Exception e5)
      {}
    }
  }
}
