/* Header file for bison C++ parser class.

   Derived from bison 1.22, Copyright (C) 1984, 1989, 1990 Bob Corbett
   and Richard Stallman.

   Modified 1996 by Nigel Topham to implement C++ parser classes.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _bison_classes_h_
#define _bison_classes_h_

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YY_LEXER
#define YY_LEXER yylex
#endif

#ifdef YYLSP_NEEDED
#define YYLEX		YY_LEXER(&yylval, &yylloc)
#else
#define YYLEX		YY_LEXER(&yylval)
#endif

/* Force a default type for YYLTYPE */

#ifndef YYLTYPE
#define YYLTYPE int
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define the class name of yyparse if not already defined */

#ifndef YY_CLASS
#define YY_CLASS BisonParser
#endif

#ifdef YYLSP_NEEDED
#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else  // no location stack
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif // YYLSP_NEEDED

class __yyClass {
protected:

  int yychar;			/*  the lookahead symbol		*/
  YYSTYPE yylval;		/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;		/*  location data for lookahead	symbol  */
#endif

  int yynerrs;			/*  number of parse errors so far       */
  int yydebug;			/*  nonzero means print parse trace	*/


  int yystate;
  int yyn;
  short *yyssp;
  YYSTYPE *yyvsp;
  int yyerrstatus;		/*  number of tokens to shift before error messages enabled */
  int yychar1;			/*  lookahead token as an internal (translated) token number */

  int yystacksize;		/*  current size of parser stack */

  short	*yyssa;			/*  the state stack base		*/
  YYSTYPE *yyvsa;		/*  the semantic value stack base	*/

  short *yyss;			/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs;		/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE *yylsa;		/*  the location stack	base		*/
  YYLTYPE *yyls;		/*  the location stack pointer		*/
  YYLTYPE *yylsp;
  YYLTYPE yylloc;
#endif // YYLSP_NEEDED

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;                    /*  number of items on rhs of rule to be reduced */

  void yyInit (int) ;
  void yyoverflow (char* msg, int* sz, short** yys, YYSTYPE** yyv, YYLTYPE** yyl) ;

  __yyClass (const int i) { yyInit (i) ; }
  ~__yyClass () ;
};

#endif /* _bison_classes_h_ */
