//
// Process Messages
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.net.*;
import java.io.*;

public class ProcessMessages
{
  public ProcessMessages(Socket sockfd, CGlobal g)
  {
    int misc;

    try 
    {
      String str_dir=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal),
                                      g.cfg.GetParamStr(g.cfgSeparator));

      PrintWriter    out=new PrintWriter   (new OutputStreamWriter(sockfd.getOutputStream()), true);
      BufferedReader in =new BufferedReader(new  InputStreamReader(sockfd.getInputStream()));

      //Get line from client
      String str1=null;
      while (str1==null)
      {
        str1=in.readLine();
      }

      //Getting line with parameters
      boolean correct=true;
      String str2="";

System.out.println(str1);

      int i1=str1.toLowerCase().indexOf("get /");
      if (i1<0) correct=false;
      else
      {
        int i2=str1.toLowerCase().indexOf("http/", i1);
        if (i2<0) correct=false;
        else
        {
          str2=str1.substring(i1+5, i2-1);
        }
      }

      str2=CMisc.DecodeURL(str2);
     
      out.println("HTTP/1.0 200 ");
      out.println("Content-Type: text/plain");
      out.println();

      if (!correct)
      {
        out.println("Error: Can't understand format of request from Client!");
      }
      else
      {
        String fl=CMisc.ProcessPath(str_dir+str2, g.cfg.GetParamStr(g.cfgSeparator));

        //Reading file
        BufferedReader fin=null;
        String x="";

        try
        {
          fin=new BufferedReader(new FileReader(fl));
        }
        catch (IOException e2)
        {
          out.println("Error: Can't find file!");
          return;
        }

        try
        {
          while ((x=fin.readLine())!=null)
          {
            out.write(x+"\n");
          }

        }
        catch (Exception e1)
        {
          try
          {
            fin.close();
          }
          catch (Exception e2)
          {}
          out.println("Error: Problems while reading file!");
          return;
        }

        try
        {
          fin.close();
        }
        catch (Exception e3)
        {}

        out.flush();
      }
    }
    catch (IOException e) 
    {
      System.out.println("Error: Problems during communication!");
      return;
    }
  }      
}
