/*
 * MPC Feedback Module 3 for ATOM (analysis)
 *
 * Copyright (C) 2000-2004 by Grigori G. Fursin
 *
 * homepage: http://homepages.inf.ed.ac.uk/gfursin
 *
 * ICSA, School of Informatics,
 * University of Edinburgh, UK
 */

#include <stdio.h>
#include <assert.h>

char dummy[1024];

FILE *fmpc1;

void MPCInit(int proc_max)
{
  int j=0;
  for (j=0; j<proc_max; j++)
  {
    sprintf(dummy, "_eos_mpc_atom2_tmp.%u", j);
    fmpc1=fopen(dummy, "w");
    fclose(fmpc1);
  }
}

void MPCRegAccess1(int proc, int inst, long reg)
{
  sprintf(dummy, "_eos_mpc_atom2_tmp.%u", proc);

  if ((fmpc1=fopen(dummy, "a"))==NULL)
  {
    fprintf(stderr, "\nFatal Error (ATOM): Can't open file!\n");
    exit(1);
  }

  fprintf(fmpc1, "\n");
  fprintf(fmpc1, "inst={%5u}, reg_value_int  ={%20ld}\n", 
                  inst, reg);

  fclose(fmpc1);
}

void MPCRegAccess2(int proc, int inst, double reg)
{
  sprintf(dummy, "_eos_mpc_atom2_tmp.%u", proc);

  if ((fmpc1=fopen(dummy, "a"))==NULL)
  {
    fprintf(stderr, "\nFatal Error (ATOM): Can't open file!\n");
    exit(1);
  }

  fprintf(fmpc1, "\n");
  fprintf(fmpc1, "inst={%5u}, reg_value_float={%20f}\n", 
                  inst, reg);

  fclose(fmpc1);
}
